DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Custom Editors

Different editors can be used to edit cell values in grid columns. The default editor depends on the column configuration. The dependency is illustrated in the editorOptions object's description (this object is used to customize the default editor). In this demo, the SelectBox component is the Status column's default editor, and the editorOptions object is used to specify the component's itemTemplate.

Backend API
$(() => { $('#gridContainer').dxDataGrid({ dataSource: DevExpress.data.AspNet.createStore({ key: 'ID', loadUrl: `${url}/Tasks`, updateUrl: `${url}/UpdateTask`, insertUrl: `${url}/InsertTask`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }), showBorders: true, paging: { enabled: true, pageSize: 15, }, pager:{ visible: true, }, headerFilter: { visible: true, }, searchPanel: { visible: true, }, editing: { mode: 'cell', allowUpdating: true, allowAdding: true, }, onRowInserted(e) { e.component.navigateToRow(e.key); }, columns: [{ dataField: 'Owner', width: 150, allowSorting: false, lookup: { dataSource: employees, valueExpr: 'ID', displayExpr: 'FullName', }, validationRules: [{ type: 'required' }], editCellTemplate: dropDownBoxEditorTemplate, }, { dataField: 'AssignedEmployee', caption: 'Assignees', width: 200, allowSorting: false, editCellTemplate: tagBoxEditorTemplate, lookup: { dataSource: employees, valueExpr: 'ID', displayExpr: 'FullName', }, validationRules: [{ type: 'required' }], cellTemplate(container, options) { const noBreakSpace = '\u00A0'; const assignees = (options.value || []).map( (assigneeId) => options.column.lookup.calculateCellValue(assigneeId), ); const text = assignees.join(', '); container.text(text || noBreakSpace).attr('title', text); }, calculateFilterExpression(filterValue, selectedFilterOperation, target) { if (target === 'search' && typeof (filterValue) === 'string') { return [this.dataField, 'contains', filterValue]; } return function (rowData) { return (rowData.AssignedEmployee || []).indexOf(filterValue) !== -1; }; }, }, { dataField: 'Subject', validationRules: [{ type: 'required' }], }, { dataField: 'Status', lookup: { dataSource: statuses, valueExpr: 'id', displayExpr: 'name', }, validationRules: [{ type: 'required' }], width: 200, editorOptions: { itemTemplate(itemData, itemIndex, itemElement) { if (itemData != null) { const imageContainer = $('<span>').addClass('status-icon middle').appendTo(itemElement); $('<img>').attr('src', `images/icons/status-${itemData.id}.svg`).appendTo(imageContainer); $('<span>').addClass('middle').text(itemData.name).appendTo(itemElement); } else { $('<span>').text('(All)').appendTo(itemElement); } }, }, }, ], }); function dropDownBoxEditorTemplate(cellElement, cellInfo) { const selectedRowKeys = cellInfo.value !== null && cellInfo.value !== undefined ? [cellInfo.value] : [] return $('<div>').dxDropDownBox({ dropDownOptions: { width: 500 }, dataSource: employees, value: cellInfo.value, valueExpr: 'ID', displayExpr: 'FullName', inputAttr: { 'aria-label': 'Owner' }, contentTemplate(e) { return $('<div>').dxDataGrid({ dataSource: employees, remoteOperations: true, columns: ['FullName', 'Title', 'Department'], hoverStateEnabled: true, scrolling: { mode: 'virtual' }, height: 250, selection: { mode: 'single' }, selectedRowKeys: selectedRowKeys, focusedRowEnabled: true, focusedRowKey: cellInfo.value, onContextMenuPreparing: (e) => { e.items = []; }, onSelectionChanged(selectionChangedArgs) { e.component.option('value', selectionChangedArgs.selectedRowKeys[0]); cellInfo.setValue(selectionChangedArgs.selectedRowKeys[0]); if (selectionChangedArgs.selectedRowKeys.length > 0) { e.component.close(); } }, }); }, }); } function tagBoxEditorTemplate(cellElement, cellInfo) { return $('<div>').dxTagBox({ dataSource: employees, value: cellInfo.value, valueExpr: 'ID', displayExpr: 'FullName', inputAttr: { 'aria-label': 'Name' }, showSelectionControls: true, maxDisplayedTags: 3, showMultiTagOnly: false, applyValueMode: 'useButtons', searchEnabled: true, onValueChanged(e) { cellInfo.setValue(e.value); }, onSelectionChanged() { cellInfo.component.updateDimensions(); }, }); } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" /> <script src="js/dx.all.js?v=25.1.6"></script> <script src="https://unpkg.com/devextreme-aspnet-data@5.0.0/js/dx.aspnet.data.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> </div> </body> </html>
.status-icon { height: 16px; width: 16px; display: inline-block; margin-right: 8px; } .middle { vertical-align: middle; }
const statuses = [{ id: 1, name: 'Not Started', }, { id: 2, name: 'In Progress', }, { id: 3, name: 'Deferred', }, { id: 4, name: 'Need Assistance', }, { id: 5, name: 'Completed', }, ]; const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridCustomEditors'; const employees = DevExpress.data.AspNet.createStore({ key: 'ID', loadUrl: `${url}/Employees`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, });

If the default editor is unsuitable, you can replace it with a custom editor. For this, implement an editCellTemplate that allows you to configure the replacement editor's appearance and behavior. To change the cell value and, optionally, the displayed value after the editor's value is changed, use the setValue() method of the editCellTemplate. In this demo, the default editors in the Owner and Assignees columns are replaced with the DropDownBox and TagBox components.

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="tasks"
[showBorders]="true"
(onRowInserted)="$event.component.navigateToRow($event.key)"
>
<dxo-data-grid-paging [enabled]="true" [pageSize]="15"></dxo-data-grid-paging>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxo-data-grid-header-filter [visible]="true"></dxo-data-grid-header-filter>
<dxo-data-grid-search-panel [visible]="true"></dxo-data-grid-search-panel>
<dxo-data-grid-editing
mode="cell"
[allowUpdating]="true"
[allowAdding]="true"
>
</dxo-data-grid-editing>
<dxi-data-grid-column
dataField="Owner"
[width]="150"
[allowSorting]="false"
editCellTemplate="singleDropDownBoxEditor"
>
<dxo-data-grid-lookup
[dataSource]="employees"
displayExpr="FullName"
valueExpr="ID"
>
</dxo-data-grid-lookup>
<dxi-data-grid-validation-rule
type="required"
></dxi-data-grid-validation-rule>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="AssignedEmployee"
caption="Assignees"
[width]="200"
[allowSorting]="false"
editCellTemplate="tagBoxEditor"
[cellTemplate]="cellTemplate"
[calculateFilterExpression]="calculateFilterExpression"
>
<dxo-data-grid-lookup
[dataSource]="employees"
valueExpr="ID"
displayExpr="FullName"
>
</dxo-data-grid-lookup>
<dxi-data-grid-validation-rule
type="required"
></dxi-data-grid-validation-rule>
</dxi-data-grid-column>
<dxi-data-grid-column dataField="Subject">
<dxi-data-grid-validation-rule
type="required"
></dxi-data-grid-validation-rule>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="Status"
width="200"
[editorOptions]="editorOptions"
>
<dxo-data-grid-lookup
[dataSource]="statuses"
displayExpr="name"
valueExpr="id"
>
</dxo-data-grid-lookup>
<dxi-data-grid-validation-rule
type="required"
></dxi-data-grid-validation-rule>
</dxi-data-grid-column>
<div *dxTemplate="let cellInfo of 'tagBoxEditor'">
<dx-tag-box
[dataSource]="employees"
[value]="cellInfo.value"
valueExpr="ID"
displayExpr="FullName"
[showSelectionControls]="true"
[maxDisplayedTags]="3"
[showMultiTagOnly]="false"
[inputAttr]="{ 'aria-label': 'Name' }"
applyValueMode="useButtons"
[searchEnabled]="true"
(onValueChanged)="cellInfo.setValue($event.value)"
(onSelectionChanged)="cellInfo.component.updateDimensions()"
>
</dx-tag-box>
</div>
<div *dxTemplate="let cellInfo of 'singleDropDownBoxEditor'">
<dx-drop-down-box
[dropDownOptions]="dropDownOptions"
[dataSource]="employees"
[(value)]="cellInfo.value"
[inputAttr]="{ 'aria-label': 'Owner' }"
displayExpr="FullName"
valueExpr="ID"
contentTemplate="contentTemplate"
>
<div *dxTemplate="let e of 'contentTemplate'">
<dx-data-grid
[dataSource]="employees"
[remoteOperations]="true"
[height]="250"
[selectedRowKeys]="getSelectedRowKeys(cellInfo.value)"
[focusedRowEnabled]="true"
[focusedRowKey]="cellInfo.value"
[hoverStateEnabled]="true"
(onContextMenuPreparing)="$event.items = []"
(onSelectionChanged)="
onSelectionChanged($event.selectedRowKeys, cellInfo, e.component)
"
>
<dxi-data-grid-column dataField="FullName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="Title"></dxi-data-grid-column>
<dxi-data-grid-column dataField="Department"></dxi-data-grid-column>
<dxo-data-grid-paging
[enabled]="true"
[pageSize]="10"
></dxo-data-grid-paging>
<dxo-data-grid-scrolling mode="virtual"></dxo-data-grid-scrolling>
<dxo-data-grid-selection mode="single"></dxo-data-grid-selection>
</dx-data-grid>
</div>
</dx-drop-down-box>
</div>
<div *dxTemplate="let status of 'statusTemplate'">
@if(status === null) {
<div>
<span>(All)</span>
</div>
} @else {
<div dx-template>
<img
src="images/icons/status-{{ status.id }}.svg"
class="status-icon middle"
/>
<span class="middle">{{ status.name }}</span>
</div>
}
</div>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxDataGridModule, DxListModule, DxDropDownBoxModule, DxTagBoxModule,
} from 'devextreme-angular';
import { createStore, CustomStore } from 'devextreme-aspnet-data-nojquery';
import { Service, Status } from './app.service';
import 'anti-forgery';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDataGridModule,
DxListModule,
DxDropDownBoxModule,
DxTagBoxModule,
],
})
export class AppComponent {
employees: CustomStore;
tasks: CustomStore;
statuses: Status[];
dropDownOptions = { width: 500 };
editorOptions = {
itemTemplate: 'statusTemplate',
};
url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridCustomEditors';
constructor(service: Service) {
this.statuses = service.getStatuses();
this.tasks = createStore({
key: 'ID',
loadUrl: `${this.url}/Tasks`,
updateUrl: `${this.url}/UpdateTask`,
insertUrl: `${this.url}/InsertTask`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
this.employees = createStore({
key: 'ID',
loadUrl: `${this.url}/Employees`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
}
getSelectedRowKeys<T>(value: T): T[] {
return value !== null && value !== undefined ? [value] : [];
}
onSelectionChanged(selectedRowKeys, cellInfo, dropDownBoxComponent) {
cellInfo.setValue(selectedRowKeys[0]);
if (selectedRowKeys.length > 0) {
dropDownBoxComponent.close();
}
}
calculateFilterExpression(filterValue, selectedFilterOperation, target) {
if (target === 'search' && typeof (filterValue) === 'string') {
return [(this as any).dataField, 'contains', filterValue];
}
return (rowData) => (rowData.AssignedEmployee || []).indexOf(filterValue) !== -1;
}
cellTemplate(container, options) {
const noBreakSpace = '\u00A0';
const assignees = (options.value || []).map(
(assigneeId: number) => options.column?.lookup?.calculateCellValue?.(assigneeId),
);
const text = assignees.join(', ');
container.textContent = text || noBreakSpace;
container.title = text;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.status-icon {
height: 16px;
width: 16px;
display: inline-block;
margin-right: 8px;
}
.middle {
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class Status {
id: number;
name: string;
}
const statuses: Status[] = [{
id: 1, name: 'Not Started',
}, {
id: 2, name: 'In Progress',
}, {
id: 3, name: 'Deferred',
}, {
id: 4, name: 'Need Assistance',
}, {
id: 5, name: 'Completed',
},
];
@Injectable()
export class Service {
getStatuses() {
return statuses;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
If the default editor is unsuitable, you can replace it with a custom editor. For this, implement an editCellTemplate that allows you to configure the replacement editor's appearance and behavior. To change the cell value and, optionally, the displayed value after the editor's value is changed, use the setValue() method of the editCellTemplate. In this demo, the default editors in the Owner and Assignees columns are replaced with the DropDownBox and TagBox components.

Backend API
import React from 'react';
import DataGrid, {
Paging,
HeaderFilter,
SearchPanel,
Editing,
Column,
Lookup,
RequiredRule,
Pager,
} from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import { statuses } from './data.ts';
import EmployeeDropDownBoxComponent from './EmployeeDropDownBoxComponent.tsx';
import EmployeeTagBoxComponent from './EmployeeTagBoxComponent.tsx';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridCustomEditors';
const statusLabel = { 'aria-label': 'Status' };
const employees = createStore({
key: 'ID',
loadUrl: `${url}/Employees`,
onBeforeSend(_method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const tasks = createStore({
key: 'ID',
loadUrl: `${url}/Tasks`,
updateUrl: `${url}/UpdateTask`,
insertUrl: `${url}/InsertTask`,
onBeforeSend(_method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const cellTemplate = (
container: { textContent: string; title: string; },
options: DataGridTypes.ColumnCellTemplateData
) => {
const noBreakSpace = '\u00A0';
const assignees = (options.value || []).map(
(assigneeId: number) => options.column.lookup?.calculateCellValue?.(assigneeId),
);
const text = assignees.join(', ');
container.textContent = text || noBreakSpace;
container.title = text;
};
interface RowDataWithAssignedEmployee {
AssignedEmployee?: number[];
}
function calculateFilterExpression(
this: DataGridTypes.Column,
filterValue: number | string,
selectedFilterOperation: DataGridTypes.SelectedFilterOperation,
target: string
) {
if (target === 'search' && typeof (filterValue) === 'string') {
return [this.dataField, 'contains', filterValue];
}
return (rowData: RowDataWithAssignedEmployee) => (rowData.AssignedEmployee || []).indexOf(filterValue as number) !== -1;
}
const onRowInserted = (e: DataGridTypes.RowInsertedEvent) => e.component.navigateToRow(e.key);
const statusEditorRender = (cell: DataGridTypes.ColumnEditCellTemplateData) => {
const onValueChanged = (e: SelectBoxTypes.ValueChangedEvent) => cell.setValue(e.value);
const itemRender = (data: { id: number, name: string } | null) => {
if (data) {
const imageSource = `images/icons/status-${data.id}.svg`;
return (
<div>
<img src={imageSource} className="status-icon middle"></img>
<span className="middle">{data.name}</span>
</div>
);
}
return <span>(All)</span>;
};
const lookupDataSource = cell.column.lookup?.dataSource;
const dataSource = typeof lookupDataSource === 'function'
? lookupDataSource({ data: cell.data, key: cell.row.key })
: lookupDataSource;
return (
<SelectBox
defaultValue={cell.value}
dataSource={dataSource}
onValueChanged={onValueChanged}
inputAttr={statusLabel}
itemRender={itemRender} />
);
};
const App = () => (
<div>
<DataGrid
dataSource={tasks}
showBorders={true}
onRowInserted={onRowInserted}
>
<Paging enabled={true} defaultPageSize={15} />
<Pager visible={true} />
<HeaderFilter visible={true} />
<SearchPanel visible={true} />
<Editing
mode="cell"
allowUpdating={true}
allowAdding={true}
/>
<Column
dataField="Owner"
width={150}
allowSorting={false}
editCellComponent={EmployeeDropDownBoxComponent}
>
<Lookup
dataSource={employees}
displayExpr="FullName"
valueExpr="ID"
/>
<RequiredRule />
</Column>
<Column
dataField="AssignedEmployee"
caption="Assignees"
width={200}
allowSorting={false}
editCellComponent={EmployeeTagBoxComponent}
cellTemplate={cellTemplate}
calculateFilterExpression={calculateFilterExpression as any}>
<Lookup
dataSource={employees}
valueExpr="ID"
displayExpr="FullName"
/>
<RequiredRule />
</Column>
<Column dataField="Subject">
<RequiredRule />
</Column>
<Column
dataField="Status"
width={200}
editCellRender={statusEditorRender}
>
<Lookup
dataSource={statuses}
displayExpr="name"
valueExpr="id"
/>
<RequiredRule />
</Column>
</DataGrid>
</div>
);
export default App;
import React from 'react';
import DataGrid, {
Paging,
HeaderFilter,
SearchPanel,
Editing,
Column,
Lookup,
RequiredRule,
Pager,
} from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import SelectBox from 'devextreme-react/select-box';
import { statuses } from './data.js';
import EmployeeDropDownBoxComponent from './EmployeeDropDownBoxComponent.js';
import EmployeeTagBoxComponent from './EmployeeTagBoxComponent.js';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridCustomEditors';
const statusLabel = { 'aria-label': 'Status' };
const employees = createStore({
key: 'ID',
loadUrl: `${url}/Employees`,
onBeforeSend(_method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const tasks = createStore({
key: 'ID',
loadUrl: `${url}/Tasks`,
updateUrl: `${url}/UpdateTask`,
insertUrl: `${url}/InsertTask`,
onBeforeSend(_method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const cellTemplate = (container, options) => {
const noBreakSpace = '\u00A0';
const assignees = (options.value || []).map((assigneeId) =>
options.column.lookup?.calculateCellValue?.(assigneeId),
);
const text = assignees.join(', ');
container.textContent = text || noBreakSpace;
container.title = text;
};
function calculateFilterExpression(filterValue, selectedFilterOperation, target) {
if (target === 'search' && typeof filterValue === 'string') {
return [this.dataField, 'contains', filterValue];
}
return (rowData) => (rowData.AssignedEmployee || []).indexOf(filterValue) !== -1;
}
const onRowInserted = (e) => e.component.navigateToRow(e.key);
const statusEditorRender = (cell) => {
const onValueChanged = (e) => cell.setValue(e.value);
const itemRender = (data) => {
if (data) {
const imageSource = `images/icons/status-${data.id}.svg`;
return (
<div>
<img
src={imageSource}
className="status-icon middle"
></img>
<span className="middle">{data.name}</span>
</div>
);
}
return <span>(All)</span>;
};
const lookupDataSource = cell.column.lookup?.dataSource;
const dataSource =
typeof lookupDataSource === 'function'
? lookupDataSource({ data: cell.data, key: cell.row.key })
: lookupDataSource;
return (
<SelectBox
defaultValue={cell.value}
dataSource={dataSource}
onValueChanged={onValueChanged}
inputAttr={statusLabel}
itemRender={itemRender}
/>
);
};
const App = () => (
<div>
<DataGrid
dataSource={tasks}
showBorders={true}
onRowInserted={onRowInserted}
>
<Paging
enabled={true}
defaultPageSize={15}
/>
<Pager visible={true} />
<HeaderFilter visible={true} />
<SearchPanel visible={true} />
<Editing
mode="cell"
allowUpdating={true}
allowAdding={true}
/>
<Column
dataField="Owner"
width={150}
allowSorting={false}
editCellComponent={EmployeeDropDownBoxComponent}
>
<Lookup
dataSource={employees}
displayExpr="FullName"
valueExpr="ID"
/>
<RequiredRule />
</Column>
<Column
dataField="AssignedEmployee"
caption="Assignees"
width={200}
allowSorting={false}
editCellComponent={EmployeeTagBoxComponent}
cellTemplate={cellTemplate}
calculateFilterExpression={calculateFilterExpression}
>
<Lookup
dataSource={employees}
valueExpr="ID"
displayExpr="FullName"
/>
<RequiredRule />
</Column>
<Column dataField="Subject">
<RequiredRule />
</Column>
<Column
dataField="Status"
width={200}
editCellRender={statusEditorRender}
>
<Lookup
dataSource={statuses}
displayExpr="name"
valueExpr="id"
/>
<RequiredRule />
</Column>
</DataGrid>
</div>
);
export default App;
import React, { useCallback, useState } from 'react';
import DataGrid, {
Column,
Paging,
Scrolling,
Selection,
} from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import DropDownBox, { type DropDownBoxTypes } from 'devextreme-react/drop-down-box';
const dropDownOptions = { width: 500 };
const ownerLabel = { 'aria-label': 'Owner' };
const EmployeeDropDownBoxComponent = (props: DataGridTypes.ColumnCellTemplateData) => {
const { data: { value: dataValue } } = props;
const initialSelectedRowKeys = dataValue !== null && dataValue !== undefined ? [dataValue] : [];
const [selectedRowKeys, setSelectedRowKeys] = useState(initialSelectedRowKeys);
const [isDropDownOpened, setDropDownOpened] = useState(false);
const boxOptionChanged = useCallback((e: DropDownBoxTypes.OptionChangedEvent) => {
if (e.name === 'opened') {
setDropDownOpened(e.value);
}
}, []);
const contentRender = useCallback(() => {
const onContextMenuPreparing = (event: DataGridTypes.ContextMenuPreparingEvent) => {
event.items = [];
};
const onSelectionChanged = (args: DataGridTypes.SelectionChangedEvent) => {
setSelectedRowKeys(args.selectedRowKeys);
setDropDownOpened(false);
props.data.setValue(args.selectedRowKeys[0]);
};
return (
<DataGrid
dataSource={props.data.column.lookup.dataSource}
remoteOperations={true}
height={250}
selectedRowKeys={selectedRowKeys}
hoverStateEnabled={true}
onContextMenuPreparing={onContextMenuPreparing}
onSelectionChanged={onSelectionChanged}
focusedRowEnabled={true}
defaultFocusedRowKey={selectedRowKeys[0]}
>
<Column dataField="FullName" />
<Column dataField="Title" />
<Column dataField="Department" />
<Paging
enabled={true}
defaultPageSize={10}
/>
<Scrolling mode="virtual" />
<Selection mode="single" />
</DataGrid>
);
}, [props.data, selectedRowKeys]);
return (
<DropDownBox
onOptionChanged={boxOptionChanged}
opened={isDropDownOpened}
dropDownOptions={dropDownOptions}
dataSource={props.data.column.lookup.dataSource}
value={selectedRowKeys[0]}
displayExpr="FullName"
valueExpr="ID"
inputAttr={ownerLabel}
contentRender={contentRender}
></DropDownBox>
);
};
export default EmployeeDropDownBoxComponent;
import React, { useCallback } from 'react';
import TagBox, { type TagBoxTypes } from 'devextreme-react/tag-box';
import type { DataGridTypes } from 'devextreme-react/data-grid';
const nameLabel = { 'aria-label': 'Name' };
const EmployeeTagBoxComponent = (props: DataGridTypes.ColumnCellTemplateData) => {
const onValueChanged = useCallback((e: TagBoxTypes.ValueChangedEvent) => {
props.data.setValue(e.value);
}, [props]);
const onSelectionChanged = useCallback(() => {
props.data.component.updateDimensions();
}, [props]);
return (
<TagBox
dataSource={props.data.column.lookup.dataSource}
defaultValue={props.data.value}
valueExpr="ID"
displayExpr="FullName"
showSelectionControls={true}
maxDisplayedTags={3}
inputAttr={nameLabel}
showMultiTagOnly={false}
applyValueMode="useButtons"
searchEnabled={true}
onValueChanged={onValueChanged}
onSelectionChanged={onSelectionChanged} />
);
};
export default EmployeeTagBoxComponent;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
// eslint-disable-next-line import/no-unresolved
import 'anti-forgery';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const statuses = [{
id: 1, name: 'Not Started',
}, {
id: 2, name: 'In Progress',
}, {
id: 3, name: 'Deferred',
}, {
id: 4, name: 'Need Assistance',
}, {
id: 5, name: 'Completed',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React, { useCallback, useState } from 'react';
import DataGrid, {
Column, Paging, Scrolling, Selection,
} from 'devextreme-react/data-grid';
import DropDownBox from 'devextreme-react/drop-down-box';
const dropDownOptions = { width: 500 };
const ownerLabel = { 'aria-label': 'Owner' };
const EmployeeDropDownBoxComponent = (props) => {
const {
data: { value: dataValue },
} = props;
const initialSelectedRowKeys = dataValue !== null && dataValue !== undefined ? [dataValue] : [];
const [selectedRowKeys, setSelectedRowKeys] = useState(initialSelectedRowKeys);
const [isDropDownOpened, setDropDownOpened] = useState(false);
const boxOptionChanged = useCallback((e) => {
if (e.name === 'opened') {
setDropDownOpened(e.value);
}
}, []);
const contentRender = useCallback(() => {
const onContextMenuPreparing = (event) => {
event.items = [];
};
const onSelectionChanged = (args) => {
setSelectedRowKeys(args.selectedRowKeys);
setDropDownOpened(false);
props.data.setValue(args.selectedRowKeys[0]);
};
return (
<DataGrid
dataSource={props.data.column.lookup.dataSource}
remoteOperations={true}
height={250}
selectedRowKeys={selectedRowKeys}
hoverStateEnabled={true}
onContextMenuPreparing={onContextMenuPreparing}
onSelectionChanged={onSelectionChanged}
focusedRowEnabled={true}
defaultFocusedRowKey={selectedRowKeys[0]}
>
<Column dataField="FullName" />
<Column dataField="Title" />
<Column dataField="Department" />
<Paging
enabled={true}
defaultPageSize={10}
/>
<Scrolling mode="virtual" />
<Selection mode="single" />
</DataGrid>
);
}, [props.data, selectedRowKeys]);
return (
<DropDownBox
onOptionChanged={boxOptionChanged}
opened={isDropDownOpened}
dropDownOptions={dropDownOptions}
dataSource={props.data.column.lookup.dataSource}
value={selectedRowKeys[0]}
displayExpr="FullName"
valueExpr="ID"
inputAttr={ownerLabel}
contentRender={contentRender}
></DropDownBox>
);
};
export default EmployeeDropDownBoxComponent;
import React, { useCallback } from 'react';
import TagBox from 'devextreme-react/tag-box';
const nameLabel = { 'aria-label': 'Name' };
const EmployeeTagBoxComponent = (props) => {
const onValueChanged = useCallback(
(e) => {
props.data.setValue(e.value);
},
[props],
);
const onSelectionChanged = useCallback(() => {
props.data.component.updateDimensions();
}, [props]);
return (
<TagBox
dataSource={props.data.column.lookup.dataSource}
defaultValue={props.data.value}
valueExpr="ID"
displayExpr="FullName"
showSelectionControls={true}
maxDisplayedTags={3}
inputAttr={nameLabel}
showMultiTagOnly={false}
applyValueMode="useButtons"
searchEnabled={true}
onValueChanged={onValueChanged}
onSelectionChanged={onSelectionChanged}
/>
);
};
export default EmployeeTagBoxComponent;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
import 'anti-forgery';
ReactDOM.render(<App />, document.getElementById('app'));
export const statuses = [
{
id: 1,
name: 'Not Started',
},
{
id: 2,
name: 'In Progress',
},
{
id: 3,
name: 'Deferred',
},
{
id: 4,
name: 'Need Assistance',
},
{
id: 5,
name: 'Completed',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.status-icon {
height: 16px;
width: 16px;
display: inline-block;
margin-right: 8px;
}
.middle {
vertical-align: middle;
}
If the default editor is unsuitable, you can replace it with a custom editor. For this, implement an editCellTemplate that allows you to configure the replacement editor's appearance and behavior. To change the cell value and, optionally, the displayed value after the editor's value is changed, use the setValue() method of the editCellTemplate. In this demo, the default editors in the Owner and Assignees columns are replaced with the DropDownBox and TagBox components.

Backend API
<template>
<DxDataGrid
:data-source="tasks"
:show-borders="true"
@row-inserted="onRowInserted"
>
<DxPaging
:enabled="true"
:page-size="15"
/>
<DxPager :visible="true"/>
<DxHeaderFilter :visible="true"/>
<DxSearchPanel :visible="true"/>
<DxEditing
:allow-updating="true"
:allow-adding="true"
mode="cell"
/>
<DxColumn
:width="150"
:allow-sorting="false"
data-field="Owner"
edit-cell-template="dropDownBoxEditor"
>
<DxLookup
:data-source="employees"
display-expr="FullName"
value-expr="ID"
/>
<DxRequiredRule/>
</DxColumn>
<DxColumn
:width="200"
:allow-sorting="false"
:cell-template="cellTemplate"
:calculate-filter-expression="calculateFilterExpression"
data-field="AssignedEmployee"
caption="Assignees"
edit-cell-template="tagBoxEditor"
>
<DxLookup
:data-source="employees"
value-expr="ID"
display-expr="FullName"
/>
<DxRequiredRule/>
</DxColumn>
<DxColumn data-field="Subject">
<DxRequiredRule/>
</DxColumn>
<DxColumn
:editor-options="{ itemTemplate: 'statusTemplate' }"
data-field="Status"
width="200"
>
<DxLookup
:data-source="statuses"
display-expr="name"
value-expr="id"
/>
<DxRequiredRule/>
</DxColumn>
<template #statusTemplate="{ data }">
<span v-if="data == null">(All)</span>
<div v-else>
<img
:src="'../../../../images/icons/status-' + data.id + '.svg'"
class="status-icon middle"
>
<span class="middle">{{ data.name }}</span>
</div>
</template>
<template #dropDownBoxEditor="{ data: cellInfo }">
<EmployeeDropDownBoxComponent
:value="cellInfo.value"
:on-value-changed="cellInfo.setValue"
:data-source="employees"
/>
</template>
<template #tagBoxEditor="{ data: cellInfo }">
<EmployeeTagBoxComponent
:cell-info="cellInfo"
:data-source="employees"
:data-grid-component="cellInfo.component"
/>
</template>
</DxDataGrid>
</template>
<script setup lang="ts">
import {
DxDataGrid,
DxPaging,
DxHeaderFilter,
DxSearchPanel,
DxEditing,
DxColumn,
DxLookup,
DxRequiredRule,
type DxDataGridTypes,
DxPager,
} from 'devextreme-vue/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import EmployeeDropDownBoxComponent from './EmployeeDropDownBoxComponent.vue';
import EmployeeTagBoxComponent from './EmployeeTagBoxComponent.vue';
import { statuses, type Task } from './data.ts';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridCustomEditors';
const employees = createStore({
key: 'ID',
loadUrl: `${url}/Employees`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const tasks = createStore({
key: 'ID',
loadUrl: `${url}/Tasks`,
updateUrl: `${url}/UpdateTask`,
insertUrl: `${url}/InsertTask`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const cellTemplate = (container: HTMLElement, options: DxDataGridTypes.ColumnCellTemplateData) => {
const noBreakSpace = '\u00A0';
const assignees = (options.value || []).map(
(assigneeId: number) => options.column!.lookup!.calculateCellValue!(assigneeId),
);
const text = assignees.join(', ');
container.textContent = text || noBreakSpace;
container.title = text;
};
const onRowInserted = (e: DxDataGridTypes.RowInsertedEvent) => {
e.component.navigateToRow(e.key);
};
function calculateFilterExpression(
this: DxDataGridTypes.Column,
filterValue: any,
selectedFilterOperations: string | null,
target: string,
) {
if (target === 'search' && typeof filterValue === 'string') {
return [this.dataField, 'contains', filterValue];
}
return ((rowData: Task) => (rowData.AssignedEmployee || []).includes(filterValue)) as () => any;
}
</script>
<style>
.status-icon {
height: 16px;
width: 16px;
display: inline-block;
margin-right: 8px;
}
.middle {
vertical-align: middle;
}
</style>
<template>
<DxDropDownBox
ref="dropDownBoxRef"
:drop-down-options="dropDownOptions"
:input-attr="{ 'aria-label': 'Owner' }"
:data-source="dataSource"
v-model:value="currentValue"
display-expr="FullName"
value-expr="ID"
content-template="contentTemplate"
>
<template #contentTemplate="{}">
<DxDataGrid
:data-source="dataSource"
:remote-operations="true"
:height="250"
:selected-row-keys="getSelectedRowKeys(currentValue)"
:hover-state-enabled="true"
:on-context-menu-preparing="onContextMenuPreparing"
:on-selection-changed="onSelectionChanged"
:focused-row-enabled="true"
:focused-row-key="currentValue"
>
<DxColumn data-field="FullName"/>
<DxColumn data-field="Title"/>
<DxColumn data-field="Department"/>
<DxPaging
:enabled="true"
:page-size="10"
/>
<DxScrolling mode="virtual"/>
<DxSelection mode="single"/>
</DxDataGrid>
</template>
</DxDropDownBox>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxDataGrid,
DxPaging,
DxSelection,
DxScrolling,
DxColumn,
type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import DxDropDownBox, { type DxDropDownBoxTypes } from 'devextreme-vue/drop-down-box';
import { CustomStore } from 'devextreme-vue/common/data';
const props = defineProps<{
value: number,
onValueChanged(value: number): void,
dataSource: CustomStore,
}>();
const currentValue = ref(props.value);
const dropDownBoxRef = ref<DxDropDownBox | null>(null);
const dropDownOptions: DxDropDownBoxTypes.Properties['dropDownOptions'] = { width: 500 };
function getSelectedRowKeys<T>(value: T | null): T[] {
return value !== null && value !== undefined ? [value] : [];
}
const onContextMenuPreparing = (e: DxDataGridTypes.ContextMenuPreparingEvent) => {
e.items = [];
};
const onSelectionChanged = (e: DxDataGridTypes.SelectionChangedEvent) => {
currentValue.value = e.selectedRowKeys[0];
props.onValueChanged(currentValue.value);
if (e.selectedRowKeys.length > 0) {
dropDownBoxRef.value!.instance!.close();
}
};
</script>
<template>
<DxTagBox
:data-source="dataSource"
v-model:value="currentValue"
:show-selection-controls="true"
:input-attr="{ 'aria-label': 'Name' }"
:max-displayed-tags="3"
:show-multi-tag-only="false"
:on-value-changed="onValueChanged"
:on-selection-changed="onSelectionChanged"
:search-enabled="true"
value-expr="ID"
display-expr="FullName"
apply-value-mode="useButtons"
/>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxDataGrid, type DxDataGridTypes } from 'devextreme-vue/data-grid';
import DxTagBox, { type DxTagBoxTypes } from 'devextreme-vue/tag-box';
import { CustomStore } from 'devextreme-vue/common/data';
const props = defineProps<{
cellInfo: DxDataGridTypes.ColumnEditCellTemplateData,
dataSource: CustomStore,
dataGridComponent: DxDataGrid['instance'],
}>();
const currentValue = ref(props.cellInfo.value);
const onSelectionChanged = () => {
props.dataGridComponent?.updateDimensions();
};
const onValueChanged = (e: DxTagBoxTypes.ValueChangedEvent) => {
props.cellInfo.setValue(e.value);
};
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export type Task = {
ID: number;
Subject: string;
Status: number;
Owner: number;
AssignedEmployee: number[];
OrderIndex: number;
Priority: number;
};
export type Employee = {
ID: number;
FullName: string;
Department: string;
Title: string;
};
export type Status = {
id: number;
name: string;
};
export const statuses: Status[] = [{
id: 1, name: 'Not Started',
}, {
id: 2, name: 'In Progress',
}, {
id: 3, name: 'Deferred',
}, {
id: 4, name: 'Need Assistance',
}, {
id: 5, name: 'Completed',
}];
import { createApp } from 'vue';
import App from './App.vue';
import 'anti-forgery';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
If the default editor is unsuitable, you can replace it with a custom editor. For this, implement an editCellTemplate that allows you to configure the replacement editor's appearance and behavior. To change the cell value and, optionally, the displayed value after the editor's value is changed, use the setValue() method of the editCellTemplate. In this demo, the default editors in the Owner and Assignees columns are replaced with the DropDownBox and TagBox components.